<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\EmissaoAutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\DTO;
use Setforms2\Shared\ORM\DateTime;

class Cmp05400 extends \Zeedhi\Framework\Controller\Report {
    protected $qr2Strategy;
    protected $stNomeRel;
    protected $environment;
    protected $filialService;
    
    public function __construct($reportService, $qr2Strategy, $environment, $filialService) {
        $this->qr2Strategy      = $qr2Strategy;
        $this->reportService	= $reportService;
        $this->environment      = $environment;
        $this->filialService    = $filialService;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
    	$row = $request->getRow();
    	$cdOperador = $this->environment->getCdOperador();
        
        if($row["FILIAL"] == "T") {
            $newFilial = $this->filialService->retornaListaDeFiliais($cdOperador);
            if(is_array($newFilial)) {
                    $str = "_";
                    foreach($newFilial as $filial) {
                        foreach($filial as $cdfilial) {
                            $str .= $cdfilial . '_';
                        }
                    }
                    $newFilial = $str;
                    $row["FILIAL"] = $newFilial;
                }
        }
        
    	$this->qr2Strategy->setQr2Type($row['QR2TYPE']);

    	$row['FILIAL1'] = $row['FILIAL'];
		$row['COMPRADOR1'] = $row['COMPRADOR'];
		$row['IMPOSTO1'] = $row['IMPOSTO'];
		$row['REGIAO1'] = $row['REGIAO'];
		$row['FORNECEDOR1'] = $row['FORNECEDOR'];
		$row['GRUPFILI1'] = $row['GRUPFILI2'] = $row['GRUPFILI3'] = $row['GRUPFILI'];
		
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
             array(
                'strategy' => $row['STRATEGY'],
                'parameterMapping'  => array(
                    'PRODINICIAL'   => 'P_CDPRODINICOC',
                    'PRODFINAL'     => 'P_CDPRODFIMCOC',
                    'TODOSPROD'     => 'L_TODOSPROD',
                    'TODOSPROD1'    => 'L_TODOSPROD1',
                    'NMPRODINICIAL'	=> 'P_NMPRODINI',
                    'NMPRODFINAL'   => 'P_NMPRODFIM',
                    'DTINI'     	=> 'P_DTINI',
                    'DTFIN'       	=> 'P_DTFIM',
                    'DTINICIAL'     => 'P_DATAINI',
                    'DTFINAL'       => 'P_DATAFIM',
                    'FILIAL'        => 'L_CDFILIAL',
                    'FILIAL1'       => 'L_CDFILIAL1',
                    'COMPRADOR'     => 'L_CDCOMPRADOR',
                    'COMPRADOR1'    => 'L_CDCOMPRADOR1',
                    'IMPOSTO'       => 'L_CDIMPOSTO',
                    'IMPOSTO1'      => 'L_CDIMPOSTO1',
                    'REGIAO'        => 'L_CDREGIAO',
                    'REGIAO1'       => 'L_CDREGIAO1',
                    'AUTOFORNE'     => 'L_AUTOFORNE',
                    'FORNECEDOR'    => 'L_CDFORNECED',
                    'FORNECEDOR1'   => 'L_CDFORNECED1',
                    'GRUPFILI'      => 'L_CDGRUPFILI',
                    'GRUPFILI1'     => 'P_CDGRUPFILI',
                    'GRUPFILI2'     => 'L_CDGRUPFILI1',
                    'GRUPFILI3'     => 'P_CDGRUPFILI1',
                    'FILIALPROC'    => 'P_CDFILIPROC',
                    'MODO'          => 'P_MODO',
                ),
            );
    }
}
